/*************************************************************************/
/*************************************************************************/
/******                                                             ******/
/******  NUMERIC UTILITIES                                          ******/
/******                                                             ******/
/*************************************************************************/
/*************************************************************************/

#include "aibstr.h"

/*-----------------------------------------------------------------------*/
/* <Round> rounds a double up if fractional portion .5 or greater.       */
/*-----------------------------------------------------------------------*/

double Round( InDbl )
double InDbl;
{
  long ModTemp;

  if ( InDbl > 99999999.9 ) return( InDbl );
  ModTemp = InDbl;  InDbl = ModTemp;  /* truncates */
  ModTemp = InDbl * 10.0;
  if ( ( ModTemp % 10 ) >= 5 )
    return( InDbl + 1.0 );
  else
    return( InDbl );
}

/*-----------------------------------------------------------------------*/
/* <HexByte> returns value of byte in hex as two character string.       */
/*-----------------------------------------------------------------------*/

char *ByteHex( InByt )
int InByt;
{
  static char ByteHexOut[3];
  char HexSet[ 17 ];

  strcpy( HexSet, "0123456789ABCDEF" );
  ByteHexOut[ 0 ] = HexSet[ ( InByt >> 4 ) & 0x0F ];
  ByteHexOut[ 1 ] = HexSet[ InByt & 0x0F ];
  ByteHexOut[ 3 ] = '\0';
  return( ByteHexOut );
}

/*-----------------------------------------------------------------------*/
/* <bool_s> returns the string TRUE or FALSE given an integer.           */
/*-----------------------------------------------------------------------*/

char *bool_s( Bool_In )
int Bool_In;
{
  static char bool_out[6];

  if ( Bool_In )
    strcpy( bool_out, "TRUE" );
  else
    strcpy( bool_out, "FALSE" );
  return( bool_out );
}

/*-----------------------------------------------------------------------*/
/* <str_d> converts a string to a double.  Lead/trail spaces stripped.   */
/* Returns true if any non-numeric or non-comma characters in string.    */
/*-----------------------------------------------------------------------*/

int str_d( InStr, d_out )
char *InStr;
double *d_out;
{
  int ChkLp;
  char CnvStr[20];
  char Valid_d[15];

  strcpy( Valid_d, "0123456789.-Ee" );
  *d_out = 0.0;
  strcpy( CnvStr, InStr );
  Strip( CnvStr );
  if ( ! *CnvStr ) return( 1 );
  Purge( CnvStr, ',' );
  if ( strspn( CnvStr, Valid_d ) < strlen( CnvStr ) )
    return( 1 );  /* some character in CnvStr not in Valid_d */
  sscanf( CnvStr, "%lf", d_out );
  return( 0 );
}

/*-----------------------------------------------------------------------*/
/* <str_l> converts a string to a long.  Lead/trail spaces stripped.     */
/* Returns true if any non-numeric or non-comma characters in string.    */
/*-----------------------------------------------------------------------*/

int str_l( InStr, l_out )
char *InStr;
long *l_out;
{
  int ChkLp;
  char CnvStr[20];
  char Valid_l[12];

  strcpy( Valid_l, "0123456789-" );
  *l_out = 0;
  strcpy( CnvStr, InStr );
  Strip( CnvStr );
  if ( ! *CnvStr ) return( 1 );
  Purge( CnvStr, ',' );
  if ( strspn( CnvStr, Valid_l ) < strlen( CnvStr ) )
    return( 1 );  /* some character in CnvStr not in Valid_l */
  sscanf( CnvStr, "%ld", l_out );
  return( 0 );
}
