/*************************************************************************/
/*************************************************************************/
/******                                                             ******/
/******  MISCELLANEOUS UTILITIES                                    ******/
/******                                                             ******/
/*************************************************************************/
/*************************************************************************/

/*-----------------------------------------------------------------------*/
/* <memmove> is a safe memcpy, s2 to s1, which allows overlapping moves. */
/* If regions overlap s2 will be destroyed.  ANSI but missing from AT&T. */ 
/*-----------------------------------------------------------------------*/

char *memmove( s1, s2, n )
char *s1, *s2;
int n;
{
  char *S1, *S2, *S3;

  if ( n && s1 && s2 )  /* check for size and nulls */
  {
    if ( s2 > s1 )
    {  /* ascending copy */
      S1 = s1;  S2 = s2;  S3 = s2 + n;
      do
      {
        *S1++ = *S2++;
      } while ( S2 != S3 );
    }
    else    
    {  /* descending copy */
      S1 = s1 + n - 1;  S2 = s2 + n - 1;  S3 = s2 - 1;
      do
      {
        *S1-- = *S2--;
      } while ( S2 != S3 );
    }      
  }
  return( s1 );
}
