/* Single keypress fetch and validate program.
   For use in simple shell script menus.
    91.10.18 AIB Created from DOS version.
    94.04.27 AIB Missing delead 2nd arg.  */

#include <stdio.h>
#include "aibstr.h"
#include "aibuser.h"

char InSet[80] = "";
char Prompt[80] = "";
int DoEat = 0;
int DoUC = 1;
int Silent = 0;
int Terse = 0;
int Found = 0;
int firstprompt = 1;
char PrevMsg[80] = "";
int MsgSeq = 0;
int SetPos = 0;
int Done = 0;
int PromptDone = 0;
char ComLine[80] = "";
int Loop;
char Ch;

/*----------------------------------------------------------------------*/

int Stop( Msg )
char *Msg;
{
  printf( "%s\n", Msg );
  exit( 0 );
}

/*------------------------------------------------------------------------*/

int WritePrompt( InMsg )
char *InMsg;
{
  char MtchMsg[80], Msg[80];
  int TmPos, SpclPos, DifPos;
  char TimeMsg[20];

  strcpy( Msg, InMsg );
  SpclPos = Pos( "/...", Msg );
  if ( SpclPos >= strlen( Msg ) )
    SpclPos = Pos( "/>>>", Msg );
  if ( SpclPos >= strlen( Msg ) )
    SpclPos = Pos( "/---", Msg );
  if ( SpclPos >= strlen( Msg ) )
    SpclPos = Pos( "/===", Msg );
  if ( SpclPos < strlen( Msg ) )
  {
    Delete( Msg, SpclPos, 1 );
    Msg[ SpclPos + MsgSeq ] = ' ';
    MsgSeq++;
    if ( ( ! firstprompt ) && ( ! kbhit() ) ) sleep( 1 );
    firstprompt = 0;
    if ( MsgSeq > 2 ) MsgSeq = 0;
  }
  strcpy( MtchMsg, Msg ); strupr( MtchMsg );
  TmPos = Pos( "/TIME", MtchMsg );
  if ( TmPos < strlen( MtchMsg ) )
  {
    strcpy( TimeMsg, TimeString() );
    Msg[ TmPos ] = TimeMsg[ 0 ];
    Msg[ TmPos + 1 ] = TimeMsg[ 1 ];
    if ( TimeMsg[ 7 ] % 2 == 0 )
      Msg[ TmPos + 2 ] = ':';
    else
      Msg[ TmPos + 2 ] = ' ';
    Msg[ TmPos + 3 ] = TimeMsg[ 3 ];
    Msg[ TmPos + 4 ] = TimeMsg[ 4 ];
  }
  if ( ( SpclPos >= strlen( Msg ) ) &&
       ( TmPos >= strlen( Msg ) ) )
  {
    PromptDone = 1;
    printf( Msg );
  }
  else
  {
    if ( strcmp( Msg, PrevMsg ) )
    {
      if ( ! *PrevMsg )
        DifPos = 0;
      else
      {
        if ( SpclPos < TmPos )
          DifPos = SpclPos;
        else
          DifPos = TmPos;
        printf( Rep( '\b', strlen( PrevMsg ) - DifPos ) );
      }
      strcpy( PrevMsg, Msg );
      printf( &Msg[ DifPos ] );
    }
  }
}

/*************************************************************************/

main( argc, argv )
int argc;
char *argv[];
{

  if ( ( argc == 1 ) ||
       ( ( argc == 2 ) && ( ! strcmp( argv[ 2 ], "?" ) ) ) )
  {
    printf( "ASQ ver 4.1 rev 94.04.27 - %s.\n", CpyRtMsg() );
    printf( "Keypress accept and validate, for simple menus.\n" );
    printf( "  Present a prompt and wait for valid keypress.\n" );
    printf( "ASQ [options] prompt [, charset]\n" );
    printf( "  Return errorlevel corresponding to position\n" );
    printf( "  in charset of pressed key.\n" );
    printf( "Options:\n" );
    printf( "  -E   Eat pending keys at startup.\n" );
    printf( "  -C   Make selection case sensitive.\n" );
    printf( "  -S   Suppress invalid key sound.\n" );
    printf( "  -T   Do not echo user keypress or carriage return.\n" );
    printf( "Prompt:\n" );
    printf( "  /TIME   Show continuous time (HH:MM) within prompt.\n" );
    printf( "  /... /--- />>> /===  Show animated portion in prompt.\n" );
    printf( "Charset:\n" );
    printf( "  Omit charset to simply accept any keypress.\n" );
    printf( "  Return value corresponds to position in character set\n" );
    printf( "    of key pressed, first character returns 1.\n" );
    exit( 0 );
  }

  /* Get full, unadulterated command line. */
  for ( Loop = 1; Loop < argc; Loop++ )
  {
    if ( *ComLine ) strcat( ComLine, " " );
    strcat( ComLine, argv[ Loop ] );
  }
  /* Parse out the prompt. */
  *Prompt = '\0';
  /* Remove leading spaces. */
  DeLead( ComLine, ' ' );
  /* Parse out options. */
  do
  {
    Found = 0;
    if ( *ComLine == '-' )
    {
      if ( toupper( ComLine[ 1 ] ) == 'E' )
      {
        DoEat = 1;
        Found = 1;
      }
      if ( toupper( ComLine[ 1 ] ) == 'C' )
      {
        DoUC = 0;
        Found = 1;
      }
      if ( toupper( ComLine[ 1 ] ) == 'S' )
      {
        Silent = 1;
        Found = 1;
      }
      if ( toupper( ComLine[ 1 ] ) == 'T' )
      {
        Terse = 1;
        Found = 1;
      }
      if ( Found )
      {
        Delete( ComLine, 0, 2 );
        DeLead( ComLine, ' ' );
      }
    }
  } while ( Found );
  /* Assemble the prompt. */
  while ( ( *ComLine ) && ( *ComLine != ',' ) )
  {
    strcat( Prompt, c_s( *ComLine ) );
    Delete( ComLine, 0, 1 );
  }
  /* Check for missing prompt. */
  if ( ! *Prompt ) Stop( "Missing prompt." );
  /* remove comma */
  if ( *ComLine == ',' ) Delete( ComLine, 0, 1 );
  /* Strip leading and trailing spaces. */
  Strip( ComLine );
  strcpy( InSet, ComLine );
  if ( DoUC ) strupr( InSet );

  READKEY_NOECHO = 1;
  stty_raw();
  if ( DoEat ) EatKeys();
  do
  {
    if ( ( *Prompt ) && ( ! PromptDone ) )
      do
        WritePrompt( Prompt );
      while ( ( ! PromptDone ) && ( ! kbhit() ) );
    Ch = ReadKey();
    if ( DoUC ) Ch = toupper( Ch );
    if ( ! *InSet )
      Done = 1;
    else
    {
      SetPos = Pos( c_s( Ch ), InSet );
      Done = SetPos < strlen( InSet );
      if ( ( ! Done ) && ( ! Silent ) ) Beep();
    }
  } while ( ! Done );
  if ( ! Terse ) printf( "%c\n", Ch );
  READKEY_NOECHO = 0;
  stty_cooked();
  exit( SetPos + 1 );

}

