// Example quick and simple fixed array sort.
// This function sorts the global sort_arr array based on the
// sort_key field in each sort_rec_type record.

#include <mem.h>  // Required for memcpy in sort.

#include <dos.h>  // Used for sleep in main.
#include <string.h>  // Used for strcpy in main.
#include <stdio.h>  // Used for printf in main.

#define MAX_SORT_RECS 99
#define MAX_SORT_DATA_LEN 80
typedef struct {
  int data_rec_key;
  char data_rec_str[MAX_SORT_DATA_LEN];
} data_rec_type;
data_rec_type data_arr[MAX_SORT_RECS];
int data_recs;

// Sort the global data array.
int sort_arr(void)
{
  int sort_gap;
  int sort_jump;
  int sort_idx;
  data_rec_type sort_rec_1;
  data_rec_type sort_rec_2;
  if ( data_recs > 1 )
  {
    sort_gap = data_recs / 2;
    while ( sort_gap > 0 )
    {
      for ( sort_idx = (sort_gap + 1); sort_idx <= data_recs; sort_idx++ )
      {
        sort_jump = sort_idx - sort_gap;
        while ( sort_jump > 0 )
        {
          memcpy( &sort_rec_1, &data_arr[sort_jump - 1],
                  sizeof(data_rec_type) );
          memcpy( &sort_rec_2, &data_arr[sort_gap + sort_jump - 1],
                  sizeof(data_rec_type) );
          if ( sort_rec_1.data_rec_key > sort_rec_2.data_rec_key )
          { /* swap */
            memcpy( &data_arr[sort_jump - 1], &sort_rec_2,
                    sizeof(data_rec_type) );
            memcpy( &data_arr[sort_gap + sort_jump - 1], &sort_rec_1,
                    sizeof(data_rec_type) );
            sort_jump = sort_jump - sort_gap;
          }
          else
            sort_jump = 0;
        }  /* while jump > 0 */
      }
      sort_gap = sort_gap / 2;
    }  /* sort */
  }
  return 0;
}


main()
{
  // Setup test data.
  strcpy(data_arr[0].data_rec_str, "This line has index 3.");
  data_arr[0].data_rec_key = 3;
  strcpy(data_arr[1].data_rec_str, "This line has index 1.");
  data_arr[1].data_rec_key = 1;
  strcpy(data_arr[2].data_rec_str, "This line has index 2.");
  data_arr[2].data_rec_key = 2;
  strcpy(data_arr[3].data_rec_str, "This line has index 5.");
  data_arr[3].data_rec_key = 5;
  strcpy(data_arr[4].data_rec_str, "This line has index 4.");
  data_arr[4].data_rec_key = 4;
  strcpy(data_arr[5].data_rec_str, "This line has index 0.");
  data_arr[5].data_rec_key = 0;
  strcpy(data_arr[6].data_rec_str, "This line has index 8.");
  data_arr[6].data_rec_key = 8;
  strcpy(data_arr[7].data_rec_str, "This line has index 7.");
  data_arr[7].data_rec_key = 7;
  data_recs = 8;
  // Display diagnostics.
  printf("Data record size: %d\n", sizeof(data_rec_type) );
  printf("Number of records: %d\n", data_recs );
  printf("Before sort:\n" );
  printf("  data_arr[0].data_rec_str: \"%s\"\n", data_arr[0].data_rec_str );
  printf("  data_arr[1].data_rec_str: \"%s\"\n", data_arr[1].data_rec_str );
  printf("  data_arr[2].data_rec_str: \"%s\"\n", data_arr[2].data_rec_str );
  printf("  data_arr[3].data_rec_str: \"%s\"\n", data_arr[3].data_rec_str );
  printf("  data_arr[4].data_rec_str: \"%s\"\n", data_arr[4].data_rec_str );
  printf("  data_arr[5].data_rec_str: \"%s\"\n", data_arr[5].data_rec_str );
  printf("  data_arr[6].data_rec_str: \"%s\"\n", data_arr[6].data_rec_str );
  printf("  data_arr[7].data_rec_str: \"%s\"\n", data_arr[7].data_rec_str );

  // Sort the data array based on the key field values.
  sort_arr();

  // Display diagnostics.
  printf("After sort:\n" );
  printf("  data_arr[0].data_rec_str: \"%s\"\n", data_arr[0].data_rec_str );
  printf("  data_arr[1].data_rec_str: \"%s\"\n", data_arr[1].data_rec_str );
  printf("  data_arr[2].data_rec_str: \"%s\"\n", data_arr[2].data_rec_str );
  printf("  data_arr[3].data_rec_str: \"%s\"\n", data_arr[3].data_rec_str );
  printf("  data_arr[4].data_rec_str: \"%s\"\n", data_arr[4].data_rec_str );
  printf("  data_arr[5].data_rec_str: \"%s\"\n", data_arr[5].data_rec_str );
  printf("  data_arr[6].data_rec_str: \"%s\"\n", data_arr[6].data_rec_str );
  printf("  data_arr[7].data_rec_str: \"%s\"\n", data_arr[7].data_rec_str );
  sleep(7);
  return 0;
}
